-- TODO
-- fix Trash group not being updated
-- fix Trash group appearing when not in raid

------------ Locals ------------

local GROUPINDEX_TANK = 1
local GROUPINDEX_HEAL = 2
local GROUPINDEX_RDPS = 3
local GROUPINDEX_MDPS = 4
local GROUPINDEX_PET = 5
local GROUPINDEX_TRASH = 6
local GROUPINDEX_TRASH_ORIGINAL = 6

local UNITS_PER_COLUMN = 5
local MAX_COLUMNS = 8

local UPDATE_DELAY = 5

local TALENT_ROLE_MAP = {["tank"]=GROUPINDEX_TANK, ["healer"]=GROUPINDEX_HEAL, ["caster"]=GROUPINDEX_RDPS, ["melee"]=GROUPINDEX_MDPS}

------------ Grid and ACE stuff ------------

GridDynamicLayout = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0")
local GridDynamicLayout_Hook = AceLibrary("AceAddon-2.0"):new("AceHook-2.1") -- ugly hack
--local BS = AceLibrary("Babble-Spell-2.2")
local L = AceLibrary("AceLocale-2.2"):new("GridDynamicLayout")
local LGT = LibStub('LibGroupTalents-1.0')

local GridLayout = Grid:GetModule("GridLayout")

L:RegisterTranslations("enUS", function()
	return {
		["Dynamic Layout"] = true,
		["Options for GridDynamicLayout."] = true,

		["ForcedHeader_title"] = "Force players into group",
		["ForcedTanks_desc"] = "Player names list separated by commas, those will always appear in the tank group",
		["ForcedHeals_desc"] = "Player names list separated by commas, those will always appear in the heal group",
		["ForcedRDPS_desc"] = "Player names list separated by commas, those will always appear in the ranged DPS group",
		["ForcedMDPS_desc"] = "Player names list separated by commas, those will always appear in the melee DPS group",
		["ForcedTanks_name"] = "Forced Tanks",
		["ForcedHeals_name"]="Forced Heals",
		["ForcedMDPS_name"]="Forced Melee DPS",
		["ForcedRDPS_name"]="Forced Ranged DPS",

		["TrashHeader_title"] = "Inactive raidmembers",
		["ActivateAFKToTrash_name"] = "AFK",
		["ActivateAFKToTrash_desc"] = "What to do with AFK players",
		["ActivateOfflineToTrash_name"] = "Offline",
		["ActivateOfflineToTrash_desc"] = "What to do with Offline players",
		["ActivateDifferentZoneToTrash_name"] = "Players in a different zone",
		["ActivateDifferentZoneToTrash_desc"] = "What to do with players in different zones",
		["ActivateNotVisibleToTrash_name"] = "Players too far away",
		["ActivateNotVisibleToTrash_desc"] = "What to do with players too far away",
		["TrashOption_noAction"] = "Leave in group",
		["TrashOption_hide"] = "Hide",
		["TrashOption_toTrashGroup"] = "To trash group",

		["PetHeader_title"] = "Optional pet group",
		["ActivateWarlockPet_name"] = "Warlock pets",
		["ActivateWarlockPet_desc"] = "If activated, warlocks pets will be added to the pet group",
		["ActivateHunterPet_name"] = "Hunter pets",
		["ActivateHunterPet_desc"] = "If activated, hunters pets will be added to the pet group",
		["ActivateDKPet_name"] = "Deathknight pets",
		["ActivateDKPet_desc"] = "If activated, deathknight pets will be added to the pet group",
		["ActivateOtherPet_name"] = "All pets",
		["ActivateOtherPet_desc"] = "If activated, all pets will be added to the pet group",
	}
end)

L:RegisterTranslations("koKR", function()
	return {
		["Dynamic Layout"] = "기능적 배치",
		["Options for GridDynamicLayout."] = "GridDynamicLayout을 위한 옵션을 설정합니다.",

		["ForcedHeader_title"] = "강요된 플레이어 그룹",
		["ForcedTanks_desc"] = "플레이어 이름 목록은 콤마에 의하여 분리되며, 언제나 탱커 그룹에 표시합니다.",
		["ForcedHeals_desc"] = "플레이어 이름 목록은 콤마에 의하여 분리되며, 언제나 힐러 그룹에 표시합니다.",
		["ForcedRDPS_desc"] = "플레이어 이름 목록은 콤마에 의하여 분리되며, 언제나 원거리 DPS 그룹에 표시합니다.",
		["ForcedMDPS_desc"] = "플레이어 이름 목록은 콤마에 의하여 분리되며, 언제나 근거리 DPS 그룹에 표시합니다.",
		["ForcedTanks_name"] = "강요된 탱커",
		["ForcedHeals_name"] = "강요된 힐러",
		["ForcedMDPS_name"] = "강요된 근거리 DPS",
		["ForcedRDPS_name"] = "강요된 원거리 DPS",

		["TrashHeader_title"] = "일반 그룹",
		["ActivateAFKToTrash_name"] = "자리비움",
		["ActivateAFKToTrash_desc"] = "만약 사용한다면, 모든 자리비움 사용자는 다음 배치 업데이트시 일반 그룹에 저장됩니다.",
		["ActivateOfflineToTrash_name"] = "오프라인",
		["ActivateOfflineToTrash_desc"] = "만약 사용한다면, 모든 오프라인 사용자는 다음 배치 업데이트시 일반 그룹에 저장됩니다.",
		["ActivateDifferentZoneToTrash_name"] = "다른 지역의 플레이어",
		["ActivateDifferentZoneToTrash_desc"] = "만약 사용한다면, 당신과 같은 지역에 있지 않는 모든 사용자는 다음 배치 업데이트시 일반 그룹에 저장됩니다.",
		["ActivateNotVisibleToTrash_name"] = "멀리 떨어진 플레이어",
		["ActivateNotVisibleToTrash_desc"] = "만약 사용한다면, 당신과 너무 멀리 떨어진 모든 사용자는 다음 배치 업데이트시 일반 그룹에 저장됩니다.",
		["TrashOption_noAction"] = "그룹 나가기",
		["TrashOption_hide"] = "숨김",
		["TrashOption_toTrashGroup"] = "일반 그룹",

		["PetHeader_title"] = "소환수 그룹 선택",
		["ActivateWarlockPet_name"] = "흑마법사 소환수",
		["ActivateWarlockPet_desc"] = "만약 사용한다면, 흑마법사의 소환수를 소환수 그룹에 추가합니다.",
		["ActivateDKPet_name"] = "Deathknight pets",
		["ActivateDKPet_desc"] = "If activated, deathknight pets will be added to the pet group",
		["ActivateHunterPet_name"] = "사냥꾼 소환수",
		["ActivateHunterPet_desc"] = "만약 사용한다면, 사냥꾼의 소환수를 소환수 그룹에 추가합니다.",
	}
end)

GridDynamicLayout = Grid:NewModule("GridDynamicLayout")
GridDynamicLayout.menuName = L["Dynamic Layout"]


-- Definition of spell info
local dynamicLayout = {
	defaults = {
		unitsPerColumn = UNITS_PER_COLUMN,
		maxColumns = MAX_COLUMNS,
		columnAnchorPoint = "LEFT",
		sortMethod="INDEX",
	},
	[GROUPINDEX_TANK] = {					 -- tanks
		nameList = "",
	},
	[GROUPINDEX_HEAL] = {					 -- healers
		nameList = "",
	},
	[GROUPINDEX_RDPS] = {					 -- ranged DPS
		nameList = "",
	},
	[GROUPINDEX_MDPS] = {					 -- melee DPS
		nameList = "",
	},
}

------------ GridDynamicLayoutACE Options -------------

GridDynamicLayout.options = {
	ForcedHeader = {
		type = "header",
		name = L["ForcedHeader_title"],
		order = 10,
	},
	ForcedTanks = {
		type = "text",
		name = L["ForcedTanks_name"],
		desc = L["ForcedTanks_desc"],
		get = function() return GridDynamicLayout:generateOptionValue(GridDynamicLayout.db.profile.tankList) end,
		usage = L["ForcedTanks_desc"],
		set = function(v)
			GridDynamicLayout.db.profile.tankList = GridDynamicLayout:parseOptionValue(v)
			GridDynamicLayout:setUpdateNeeded("Forced Tank update")
		end,
		order = 11,
	},
	ForcedHeals = {
		type = "text",
		name = L["ForcedHeals_name"],
		desc = L["ForcedHeals_desc"],
		get = function() return GridDynamicLayout:generateOptionValue(GridDynamicLayout.db.profile.healList) end,
		usage = L["ForcedHeals_desc"],
		set = function(v)
			GridDynamicLayout.db.profile.healList = GridDynamicLayout:parseOptionValue(v)
			GridDynamicLayout:setUpdateNeeded("Forced Heal update")
		end,
		order = 12,
	},
	ForcedMDPS = {
		type = "text",
		name = L["ForcedMDPS_name"],
		desc = L["ForcedMDPS_desc"],
		get = function() return GridDynamicLayout:generateOptionValue(GridDynamicLayout.db.profile.MDPSList) end,
		usage = L["ForcedMDPS_desc"],
		set = function(v)
			GridDynamicLayout.db.profile.MDPSList = GridDynamicLayout:parseOptionValue(v)
			GridDynamicLayout:setUpdateNeeded("Forced melee DPS update")
		end,
		order = 13,
	},
	ForcedRDPS = {
		type = "text",
		name = L["ForcedRDPS_name"],
		desc = L["ForcedRDPS_desc"],
		get = function() return GridDynamicLayout:generateOptionValue(GridDynamicLayout.db.profile.RDPSList) end,
		usage = L["ForcedRDPS_name"],
		set = function(v)
			GridDynamicLayout.db.profile.RDPSList = GridDynamicLayout:parseOptionValue(v)
			GridDynamicLayout:setUpdateNeeded("Forced range DPS update")
		end,
		order = 14,
	},

	TrashHeader = {
		type = "header",
		name = L["TrashHeader_title"],
		order = 20,
	},
	ActivateAFKToTrash = {
		type = "text",
		name = L["ActivateAFKToTrash_name"],
		desc = L["ActivateAFKToTrash_desc"],
		get = function() return GridDynamicLayout.db.profile.modeAFK end,
		set = function(v)
			GridDynamicLayout.db.profile.modeAFK = v
			GridDynamicLayout:setUpdateNeeded("AFK mode changed")
		end,
		validate = {["noAction"]=L["TrashOption_noAction"],["hide"]=L["TrashOption_hide"], ["toTrashGroup"]=L["TrashOption_toTrashGroup"]},
		order = 21,
	},
	ActivateOfflineToTrash = {
		type = "text",
		name = L["ActivateOfflineToTrash_name"],
		desc = L["ActivateOfflineToTrash_desc"],
		get = function() return GridDynamicLayout.db.profile.modeOffline end,
		set = function(v)
			GridDynamicLayout.db.profile.modeOffline = v
			GridDynamicLayout:setUpdateNeeded("Offline mode changed")
		end,
		validate = {["noAction"]=L["TrashOption_noAction"],["hide"]=L["TrashOption_hide"], ["toTrashGroup"]=L["TrashOption_toTrashGroup"]},
		order = 22,
	},
	ActivateDifferentZoneToTrash = {
		type = "text",
		name = L["ActivateDifferentZoneToTrash_name"],
		desc = L["ActivateDifferentZoneToTrash_desc"],
		get = function() return GridDynamicLayout.db.profile.modeDifferentZone end,
		set = function(v)
			GridDynamicLayout.db.profile.modeDifferentZone = v
			GridDynamicLayout:setUpdateNeeded("Different zone mode changed")
		end,
		validate = {["noAction"]=L["TrashOption_noAction"],["hide"]=L["TrashOption_hide"], ["toTrashGroup"]=L["TrashOption_toTrashGroup"]},
		order = 23,
	},
	ActivateNotVisibleToTrash = {
		type = "text",
		name = L["ActivateNotVisibleToTrash_name"],
		desc = L["ActivateNotVisibleToTrash_desc"],
		get = function() return GridDynamicLayout.db.profile.modeNotVisible end,
		set = function(v)
			GridDynamicLayout.db.profile.modeNotVisible = v
			GridDynamicLayout:setUpdateNeeded("Not visible mode changed")
		end,
		validate = {["noAction"]=L["TrashOption_noAction"],["hide"]=L["TrashOption_hide"], ["toTrashGroup"]=L["TrashOption_toTrashGroup"]},
		order = 24,
	},

	PetHeader = {
		type = "header",
		name = L["PetHeader_title"],
		order = 30,
	},
	ActivateOtherPet = {
		type = "toggle",
		name = L["ActivateOtherPet_name"],
		desc = L["ActivateOtherPet_desc"],
		get = function() return GridDynamicLayout.db.profile.activateOtherPet end,
		set = function(v)
			GridDynamicLayout.db.profile.activateOtherPet = v
			if v then
			     GridDynamicLayout.db.profile.activateHunterPet = false
			     GridDynamicLayout.db.profile.activateWarlockPet = false
			     GridDynamicLayout.db.profile.activateDKPet = false
			end
			GridDynamicLayout:setUpdateNeeded("Toggle Other Pets")
		end,
		order = 31,
	},
	ActivateWarlockPet = {
		type = "toggle",
		name = L["ActivateWarlockPet_name"],
		desc = L["ActivateWarlockPet_desc"],
		get = function() return GridDynamicLayout.db.profile.activateWarlockPet end,
		set = function(v)
			GridDynamicLayout.db.profile.activateWarlockPet = v
			GridDynamicLayout:setUpdateNeeded("Toggle Warlocks Pets")
		end,
		disabled = function()
            return GridDynamicLayout.db.profile.activateOtherPet
        end,
		order = 32,
	},
	ActivateHunterPet = {
		type = "toggle",
		name = L["ActivateHunterPet_name"],
		desc = L["ActivateHunterPet_desc"],
		get = function() return GridDynamicLayout.db.profile.activateHunterPet end,
		set = function(v)
			GridDynamicLayout.db.profile.activateHunterPet = v
			GridDynamicLayout:setUpdateNeeded("Toggle Hunters Pets")
		end,
		disabled = function()
            return GridDynamicLayout.db.profile.activateOtherPet
        end,
		order = 33,
	},
	ActivateDKPet = {
		type = "toggle",
		name = L["ActivateDKPet_name"],
		desc = L["ActivateDKPet_desc"],
		get = function() return GridDynamicLayout.db.profile.activateDKPet end,
		set = function(v)
			GridDynamicLayout.db.profile.activateDKPet = v
			GridDynamicLayout:setUpdateNeeded("Toggle DK Pets")
		end,
		disabled = function()
            return GridDynamicLayout.db.profile.activateOtherPet
        end,
		order = 34,
	},
}

function GridDynamicLayout:parseOptionValue(s)
	local result = {}
	if string.find(s, ",") then
		for a in gmatch(s..",", "(.-),") do
			if a ~= "" then
				result[a] = true
			end
		end
	elseif s ~= "" then
		result[s] = true
	end
	return result
end

function GridDynamicLayout:generateOptionValue(list)
	local result = ""
	for key,value in pairs(list) do
		if value then
			result = result .. key .. ","
		end
	end
	return result
end

-- Hook into GridLayout options
GridLayout.options.args["DynamicLayout"] = {
	type = "group",
	name = L["Dynamic Layout"],
	desc = L["Options for GridDynamicLayout."],
	disabled = InCombatLockdown,
	args = GridDynamicLayout.options
}

------------ GridDynamicLayoutDefaultDB -------------

GridDynamicLayout.defaultDB = {
	dbVersion = 1.2,
	debug=false,
	modeAFK="noAction",
	modeOffline="noAction",
	modeDifferentZone="noAction",
	modeNotVisible="noAction",
	activateWarlockPet=true,
	activateHunterPet=true,
	activateDKPet=true,
	activateOtherPet=false,
	tankList = {},
	healList = {},
	MDPSList = {},
	RDPSList = {},
}

------------ Addon events handling ------------

function GridDynamicLayout:OnInitialize()
	self.super.OnInitialize(self)
	-- Initializes session-specific data
	self.ExitingCombatScheduled = false
	self.layoutActivated = false
	self.updateNeeded = false
	self.rosterRoles = {}
   self.afkUnits = {}
   self.offlineUnits = {}
   self.differentZoneUnits = {}
   self.notVisibleUnits = {}
   self.namesToUnit = {}
end

function GridDynamicLayout:OnEnable()
	GridDynamicLayout_Hook:SecureHook(GridLayout, "LoadLayout", "hook_LoadLayout")
	LGT.RegisterCallback(self, 'LibGroupTalents_RoleChange')
end

------------ Helper functions ------------
local function wipeTable(t)
   for k, _ in pairs(t) do
      t[k] = nil
   end
end

function GridDynamicLayout_Hook:hook_LoadLayout(self, layoutName)
	if layoutName == "Dynamic Layout" then
		GridDynamicLayout:onLayoutActivation()
	else
		GridDynamicLayout:onLayoutInactivation()
	end
end

function GridDynamicLayout:setUpdateNeeded(reason)
	self:Debug("Update needed - " .. reason)
	self.updateNeeded = true
end


function GridDynamicLayout:onLayoutInactivation()
	if self.layoutActivated then
		self:CancelScheduledEvent("GridDynamicLayout_CheckUpdate")
		self:UnregisterEvent("GridDynamicLayout_CheckUpdate")
		self:CancelScheduledEvent("GridDynamicLayout_CheckTrash")
		self:UnregisterEvent("GridDynamicLayout_CheckTrash")
      self:UnregisterEvent("Grid_UnitLeft")
		self:UnregisterEvent("Grid_UnitJoined")
		self:Debug("Unregistered events")
	end
	self.layoutActivated = false
end

function GridDynamicLayout:onLayoutActivation()
	if not self.layoutActivated then
		self:ScheduleRepeatingEvent("GridDynamicLayout_CheckUpdate", UPDATE_DELAY)
		self:RegisterEvent("GridDynamicLayout_CheckUpdate", "initializeLayout")
		self:ScheduleRepeatingEvent("GridDynamicLayout_CheckTrash", UPDATE_DELAY)
		self:RegisterEvent("GridDynamicLayout_CheckTrash", "checkTrash")
		self:RegisterEvent("Grid_UnitLeft", "initializeLayoutLeft")
		self:RegisterEvent("Grid_UnitJoined", "initializeLayoutJoin")
		self:Debug("Registered events")
		wipeTable(self.afkUnits)
    	wipeTable(self.offlineUnits)
    	wipeTable(self.differentZoneUnits)
    	wipeTable(self.notVisibleUnits)
	end
	self.layoutActivated = true
end

function GridDynamicLayout:initializeLayoutLeft(name)
	self:setUpdateNeeded("Unit Left - "..name)
end

function GridDynamicLayout:initializeLayoutJoin(name, unitid)
	self:setUpdateNeeded("Unit Join - "..name.." ("..unitid..")")
end

local function getRealmedName(unit)
	local name, realm = UnitName(unit)

	if realm ~= nil and realm ~= "" then
		name = name .. "-" .. realm
	end

	return name
end

function GridDynamicLayout:addToGroup(grpNumber, unit)
	local name = getRealmedName(unit)
	if grpNumber==nil then
		self:Debug(name .. " (".. unit .. ") : is hidden" )
	elseif not dynamicLayout[grpNumber] then
		self:Debug("Attempted to add " .. name .. " (".. unit .. ") to non existing group number : " .. grpNumber )
	else
		dynamicLayout[grpNumber].nameList = dynamicLayout[grpNumber].nameList .. name .. ","
	end
end

local function getPetGroupFilter(hasOther, hasHunter, hasWarlock, hasDK)
    if hasOther then
        return nil
	else
		local list = {}
		if hasHunter then table.insert(list, "HUNTER") end
		if hasWarlock then table.insert(list, "WARLOCK") end
		if hasDK then table.insert(list, "DEATHKNIGHT") end
		if #list == 1 then
			return list[1]
		end
		local result = ""
		for i = 1, #list-1 do
			result = result .. list[i] .. ","
		end
		result = result .. list[#list]
		return result
	end
end

function GridDynamicLayout:initializeLayout()
	if not self.updateNeeded then
		return
	end

	self:Debug("----- Initializing Layout ------")

    -- create or delete pet group as needed
	if self.db.profile.activateWarlockPet or
		self.db.profile.activateHunterPet or
		self.db.profile.activateDKPet or
		self.db.profile.activateOtherPet
	then
		if dynamicLayout[GROUPINDEX_PET] == nil then
			dynamicLayout[GROUPINDEX_PET] = {
			}
		end
		dynamicLayout[GROUPINDEX_PET].isPetGroup = true
		dynamicLayout[GROUPINDEX_PET].filterOnPet = true
		dynamicLayout[GROUPINDEX_PET].groupFilter = getPetGroupFilter(self.db.profile.activateOtherPet, self.db.profile.activateHunterPet, self.db.profile.activateWarlockPet, self.db.profile.activateDKPet)
		-- If pet group activated then trash group index must be original
		GROUPINDEX_TRASH = GROUPINDEX_TRASH_ORIGINAL
	else
	    if dynamicLayout[GROUPINDEX_PET] ~= nil then
			dynamicLayout[GROUPINDEX_PET] = nil
		end
		-- If pet group not activated then trash group index must be pet group index
		GROUPINDEX_TRASH = GROUPINDEX_PET
		if dynamicLayout[GROUPINDEX_TRASH_ORIGINAL] ~= nil then
			dynamicLayout[GROUPINDEX_TRASH_ORIGINAL] = nil
		end
	end

	-- create or delete trash group as needed
	if UnitInRaid("player") and (
      self.db.profile.modeAFK == "toTrashGroup" or
      self.db.profile.modeOffline == "toTrashGroup" or
      self.db.profile.modeDifferentZone == "toTrashGroup" or
      self.db.profile.modeNotVisible == "toTrashGroup"
   ) then
		if dynamicLayout[GROUPINDEX_TRASH] == nil then
			dynamicLayout[GROUPINDEX_TRASH] = {
				nameList = "",
			}
			dynamicLayout[GROUPINDEX_TRASH].isPetGroup = nil
		   dynamicLayout[GROUPINDEX_TRASH].filterOnPet = nil
		end
	else
		if dynamicLayout[GROUPINDEX_TRASH] ~= nil then
			dynamicLayout[GROUPINDEX_TRASH] = nil
		end
	end

	for _,v in pairs(dynamicLayout) do
		if v.nameList then
			v.nameList = ""
		end
	end

	-- Sorts raid by class / name
	sortedRaid = {}
	if UnitInRaid("player") then
		for i=1,40 do
			if UnitExists("raid"..i) then
				table.insert(sortedRaid, "raid"..i)
			end
		end
	elseif GetNumPartyMembers() > 0 then
		for i=1,4 do
			if UnitExists("party"..i) then
				table.insert(sortedRaid, "party"..i)
			end
		end
		table.insert(sortedRaid, "player")
	else
		table.insert(sortedRaid, "player")
	end

	table.sort(sortedRaid, function(a, b)
		local _, aClass = UnitClass(a)
		local _, bClass = UnitClass(b)
		if aClass and bClass then
			if aClass < bClass then
				return true
			elseif aClass == bClass and UnitName(a) < UnitName(b) then
				return true
			else
				return false
			end
		end
		return false
	end)

	-- Scans the raid and place each unit in appropriate nameList
	self:Debug("--------------")
	for i=1,#sortedRaid do
		if UnitExists(sortedRaid[i]) then
			self:addToGroup(self:getLayoutGroupIndex(sortedRaid[i]), sortedRaid[i])
		end
	end
	self:Debug("--------------")


	if GridLayout.db.profile.layout == "Dynamic Layout" then
		if not InCombatLockdown() then
			GridLayout:ReloadLayout()
		elseif not self.ExitingCombatScheduled then
			self:ScheduleLeaveCombatAction(GridDynamicLayout, "ExitingCombat")
			self.ExitingCombatScheduled = true
		end
	end
	self.updateNeeded = false
end

function GridDynamicLayout:ExitingCombat()
	self:ScheduleLeaveCombatAction(GridLayout, "ReloadLayout")
	self.ExitingCombatScheduled = false
end

function GridDynamicLayout:getLayoutGroupIndex(unit)
	-- trash group options are only activated in raid
	local zone, isOnline, isAfk, isVisible = GetRealZoneText(), true, false, true
	if string.sub(unit, 1, 4) == "raid" then
		local raidIndex = string.sub(unit, 5)
		_, _, _, _, _, _, zone, online = GetRaidRosterInfo(raidIndex)
		isAfk = UnitIsAFK(unit)
		isVisible = UnitIsVisible(unit)
	end

	-- Add to trash group if not in right subzone / is offline etc...
	local name = getRealmedName(unit)
	if
		(self.db.profile.modeAFK == "toTrashGroup" and self.afkUnits[name]) or
		(self.db.profile.modeOffline == "toTrashGroup" and self.offlineUnits[name]) or
		(self.db.profile.modeDifferentZone == "toTrashGroup" and self.differentZoneUnits[name]) or
		(self.db.profile.modeNotVisible == "toTrashGroup" and self.notVisibleUnits[name])
	then
		return GROUPINDEX_TRASH
	elseif
		(self.db.profile.modeAFK == "hide" and self.afkUnits[name]) or
		(self.db.profile.modeOffline == "hide" and self.offlineUnits[name]) or
		(self.db.profile.modeDifferentZone == "hide" and self.differentZoneUnits[name]) or
		(self.db.profile.modeNotVisible == "hide" and self.notVisibleUnits[name])
	then
		return nil -- unit is not in any group (unit is hidden)
	-- Add to tanks if "by name" setting used
	elseif self.db.profile.tankList[UnitName(unit)] then
		return GROUPINDEX_TANK
	-- Add to healers if "by name" setting used
	elseif self.db.profile.healList[UnitName(unit)] then
		return GROUPINDEX_HEAL
	-- Add to ranged DPS if "by name" setting used
	elseif self.db.profile.RDPSList[UnitName(unit)] then
		return GROUPINDEX_RDPS
	-- Add to melee DPS if "by name" setting used
	elseif self.db.profile.MDPSList[UnitName(unit)] then
		return GROUPINDEX_MDPS
	-- Use class / buff setting to assign role
	else
		local class
		_, class = UnitClass(unit)

		-- Add Hunters, Mages and Warlocks to ranged DPS group
		if class=="HUNTER" or class=="MAGE" or class=="WARLOCK" then
			return GROUPINDEX_RDPS
		-- Add Rogues to melee DPS group
		elseif class=="ROGUE" then
			return GROUPINDEX_MDPS
		else
			if UnitIsUnit(unit, "player") then unit = "player" end -- role change for player is updated under player, not raid[X]
			-- if Group Talents info is available return it
			local role = self.rosterRoles[getRealmedName(unit)]
			if role then
				return TALENT_ROLE_MAP[role]
			-- else resort to a default role for class
			elseif class=="PRIEST" or class=="SHAMAN" or class=="DRUID" or class=="PALADIN" then
				 return GROUPINDEX_HEAL
			else
				return GROUPINDEX_MDPS
			end
		end
	end
end

----------------- Handling GroupTalents events -----------------

function GridDynamicLayout:LibGroupTalents_RoleChange(_, guid, unit, newRole, oldRole)
	if UnitIsUnit(unit, "player") then unit = "player" end
	self.rosterRoles[getRealmedName(unit)] = newRole
	self:setUpdateNeeded(string.format("Role change detected : %s=%s (%s > %s)", unit, UnitName(unit), oldRole or "unknown", newRole))
end

----------------- Handling the checkTrash event -----------------

local function unitIsNotOnline(unit)
	if not unit then return false end
	local raidIndex = string.sub(unit, 5)
	local _, _, _, _, _, _, _, online = GetRaidRosterInfo(raidIndex)
	return not online
end

local function unitIsInDifferentZone(unit)
	if not unit then return false end
	local raidIndex = string.sub(unit, 5)
	local _, _, _, _, _, _, zone = GetRaidRosterInfo(raidIndex)
	return (zone ~= GetRealZoneText())
end

local function unitIsNotVisible(unit)
   return not UnitIsVisible(unit)
end

-- helper function : update trash list passed using criteria function provided
function GridDynamicLayout:updateTrashUnits(mode, names, shouldBeListed)
   if mode == "noAction" then return end

   local updateNeeded = false
   -- remove units from list if criteria function passed is not true anymore
   for name, _ in pairs(names) do
      if not shouldBeListed(self.namesToUnit[name]) then
         --self:Debug("Remove "..unit)
         names[name] = nil
         updateNeeded = true
      end
   end
   -- adds units from list if criteria function passed is now true
   for raidIndex=1, 40 do
       local unit = "raid"..raidIndex
       local name = getRealmedName(unit)
       if UnitExists(unit) and shouldBeListed(unit) and not names[name] then
         --self:Debug("Add "..UnitName(unit))
  		   names[name] = true
  		   updateNeeded = true
  		end
   end

   if updateNeeded then
      self:setUpdateNeeded("Trash group change")
   end
end

function GridDynamicLayout:checkTrash()
   -- If player is not in raid, disable
   if not UnitInRaid("player") then return end

   -- Handling afk list
   if
      self.db.profile.modeAFK ~= "noAction" or
      self.db.profile.modeOffline ~= "noAction" or
      self.db.profile.modeDifferentZone ~= "noAction" or
      self.db.profile.modeNotVisible ~= "noAction"
   then
   	-- update names to units table
   	wipeTable(self.namesToUnit)
		for i = 1, 40 do
   		local unit = "raid"..i
   		if UnitExists(unit) then
   			self.namesToUnit[getRealmedName(unit)] = unit
   		end
   	end
      -- update AFK list
      self:updateTrashUnits(self.db.profile.modeAFK, self.afkUnits, UnitIsAFK)
      -- update offline list
      self:updateTrashUnits(self.db.profile.modeOffline, self.offlineUnits, unitIsNotOnline)
      -- update different zone list
      self:updateTrashUnits(self.db.profile.modeDifferentZone, self.differentZoneUnits, unitIsInDifferentZone)
      -- update not visible list
      self:updateTrashUnits(self.db.profile.modeNotVisible, self.notVisibleUnits, unitIsNotVisible)
   end
end

-- Adds dynamic layout to Grid's layouts
GridLayout:AddLayout("Dynamic Layout", dynamicLayout)
